%define anolis_release 2
%define mod_name LWP-Protocol-https
%bcond_with perl_LWP_Protocol_https_enables_internet_test

Name:           perl-LWP-Protocol-https
Version:        6.10
Release:        %{anolis_release}%{?dist}
Summary:        Provide HTTPS support for LWP::UserAgent
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/%{mod_name}
Source0:        https://cpan.metacpan.org/authors/id/O/OA/OALDERS/%{mod_name}-%{version}.tar.gz
Source1:        test.sh

Patch1:         0001-LWP-Protocol-https-don-t-disale-verification-if-only-host.patch
Patch2:         0002-LWP-Protocol-https-fix-test-make-it-workable-for-Crypt-SS.patch

BuildRequires:  make coreutils
BuildRequires:  perl-interpreter perl-generators
BuildRequires:  perl(warnings) perl(strict)
BuildRequires:  perl(:VERSION) >= 5.8.1
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(base)
BuildRequires:  perl(Net::HTTPS) >= 6
BuildRequires:  perl(Mozilla::CA) >= 20180117
BuildRequires:  perl(LWP::Protocol::http)
BuildRequires:  perl(LWP::Protocol::http::SocketMethods)
BuildRequires:  perl(IO::Socket::SSL) >= 1.54
BuildRequires:  perl(Socket) perl(blib)
BuildRequires:  perl(File::Temp) perl(File::Spec)
BuildRequires:  perl(IO::Socket::INET) perl(IO::Select)
BuildRequires:  perl(LWP::UserAgent) >= 6.06
BuildRequires:  perl(Test::More) >= 0.96
BuildRequires:  perl(IO::Socket::SSL::Utils)
BuildRequires:  perl(IO::Socket::SSL) >= 1.953
%if %{with perl_LWP_Protocol_https_enables_internet_test}
BuildRequires:  perl(Test::RequiresInternet)
%endif

Requires:       perl(Net::HTTPS) >= 6
Requires:       perl(Mozilla::CA) >= 20180117
Requires:       perl(IO::Socket::SSL) >= 1.54

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(Net::HTTPS\\)\\s*$

BuildArch:      noarch

%description
The LWP::Protocol::https module provides support for using HTTPS schemed
URLs with LWP. This module is a plug-in to the LWP protocol handling, so
you don't use it directly. Once the module is installed LWP is able to
access sites using HTTP over SSL/TLS.

%package        tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness

%description    tests
Tests from %{name}. Execute them with "%{_libexecdir}/%{name}/test".

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{mod_name}-%{version}

%if !%{with perl_LWP_Protocol_https_enables_internet_test}
rm t/apache.t
perl -i -ne 'print $_ unless m{^t/apache.t}' MANIFEST
%endif
for F in $(find t/ -name '*.t'); do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!\s*perl}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL NO_PACKLIST=1 NO_PERLLOCAL=1 INSTALLDIRS=vendor
%make_build

%install
%make_install

mkdir -p %{buildroot}%{_libexecdir}/%{name}/t 
install -m 0644 t/00-report-prereqs.dd %{buildroot}%{_libexecdir}/%{name}/t/00-report-prereqs.dd
install -m 0755 t/00-report-prereqs.t %{buildroot}%{_libexecdir}/%{name}/t/00-report-prereqs.t
install -m 0755 t/https_proxy.t %{buildroot}%{_libexecdir}/%{name}/t/https_proxy.t
install -m 0755 t/method_in_san.t %{buildroot}%{_libexecdir}/%{name}/t/method_in_san.t
rm -f %{buildroot}%{_libexecdir}/%{name}/t/00*
install -m 0755 %{SOURCE1} %{buildroot}%{_libexecdir}/%{name}/test
%{_fixperms} %{buildroot}/*

%check
make test

%files
%license LICENSE
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}/test
%{_libexecdir}/%{name}/t/https_proxy.t
%{_libexecdir}/%{name}/t/method_in_san.t

%files doc
%doc Changes

%changelog
* Thu Apr 13 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 6.10-2
- Optimise spec file

* Tue Feb 14 2023 happy_orange <songnannan@linux.alibaba.com> - 6.10-1
- package import to anolis23
